// combstr.h

#ifndef _COMBSTR_H
#define _COMBSTR_H

#if HOSTOS==MSDOS
#include <wchar.h>
#include <string.h>
#include <wtypes.h>
#else
#include <string.h>
#endif

#include <string>
//#include "MWLangDefs.h"

#define CComVariantBool(x,y)	CComVariant x; \
								x.vt=VT_BOOL; \
								x.boolVal = y;

#define CComVariantUI1(x,y)		CComVariant x; \
								x.vt=VT_UI1; \
								x.bVal = (BYTE)y;

#define CComVariantUI4(x,y)		CComVariant x; \
								x.vt=VT_UI4; \
								x.ulVal=y;

#define CComVariantI4(x,y)		CComVariant x; \
								x.vt=VT_I4; \
								x.lVal=y;

#define CComVariantUI8(x,y) 	CComVariant x; \
								x.vt=VT_UI8; \
								memcpy(&(x.ullVal),y,8);

#define CComVariantByRef(x,y)	CComVariant x; \
								x.vt = VT_BYREF; \
								x.byref=y;

#if (HOSTOS==LINUX) || (HOSTOS==SOLARIS)
#define WIDECHARTEXTPREFIX(X) X
#else
// do not erase double #'s in the following macro.
// The first one deletes the " " (space) generated by the macro expansion. The second one 
// deletes the original space in the macro. 
// For example 
//		WIDECHARTEXTPREFIX("baklava") is expanded into L"baklava"
// - TU, DRR, DS (three stooges)
// ha!  you three really are stooges.  that thing is a C preprocessor
// concat operator ... it has nothing to do with deleting spaces.
#define WIDECHARTEXTPREFIX(X) L## X
#endif

size_t bstrlen(BSTR str);

int bstrcmp(BSTR str1, BSTR str2);

int bstrcmp(const char *str1, BSTR str2);

int bstrcmp(BSTR str1, const char *str2);

char* bstrcpy(char* str1, BSTR str2);

char* bstrncpy(char *str1, BSTR str2, long len);

char* bstralloccpy(BSTR str);

unsigned char* bstrtomb(unsigned char *dest, BSTR src, unsigned int size);

// Returns false if conversion did not complete due to invalid unicode char or src==NULL
bool bstrtomb(std::string& dest, BSTR src);	

BSTR mbtobstr(BSTR dest, unsigned char *src, unsigned int size);

void mbtobstrwithallocate(BSTR *dest, const unsigned char *src, unsigned int len);

//char* FormatHex(const char* bytes, long len, char* formatBuf, ELanguage lang, bool prependIdentifier);
//char* FormatHexLen(const char* bytes, long len, char* formatBuf, long formatBufLen, ELanguage lang, bool prependIdentifier);


void ScanFromHex(const char* memoryString, char* memBuffer);

#endif //_COMBSTR_H
