
#include "osbdm_utilities.h"
#include <atlbase.h>
#include "combstr.h"

CComVariant * createVariantSafeArrayOfBSTRs(char * inArray[],int size)
{
	SAFEARRAY *outArray;
	SAFEARRAYBOUND bounds[1];
	
	USES_CONVERSION;  // enables use of ATL conversion macro A2W

	bounds[0].cElements = size;
	bounds[0].lLbound = 0;
	outArray = SafeArrayCreateEx(VT_BSTR,1,bounds,NULL);
	
	HRESULT hr;

	if (outArray != NULL) {

		for (unsigned long i=0;i< bounds[0].cElements;i++) {
			long index[1];
			index[0] = i;

			
			BSTR wStr = ::SysAllocString(A2W(inArray[i]));

			if (wStr==NULL) {
			    SafeArrayDestroy(outArray); 
				return NULL;
			}

			hr=SafeArrayPutElement(outArray,index,wStr);

			//SafeArrayPutElement apparently does a copy, so we should release this memory
			::SysFreeString(wStr);

			if (hr != S_OK) {
			    SafeArrayDestroy(outArray); 
				return NULL;
			}

		}
	}

	CComVariant *namesVariant = new CComVariant();

	VariantInit(namesVariant);
	namesVariant->vt = VT_ARRAY | VT_BSTR;
	namesVariant->parray = outArray;


//#define TEST_CODE 1

#ifdef TEST_CODE
	{
			BSTR *pName;

			INIT_SAFEARRAY_ACCESS(namesVariant->parray,pName);

			int maxPorts = _upperBound+1;
			unsigned char **possible_ports=NULL;

			possible_ports = new  unsigned char *[maxPorts];
			//*pszEntries = (char **)possible_ports;


			BEGIN_SAFEARRAY_LOOP
				possible_ports[SA_INDEX] = new unsigned char[wcslen(pName[SA_INDEX])+1];
				bstrtomb(possible_ports[SA_INDEX],pName[SA_INDEX],bstrlen(pName[SA_INDEX])+1);
			END_SAFEARRAY_LOOP 
	}

#endif

	return namesVariant;
}

HRESULT destroyVariantSafeArrayOfBSTRs(CComVariant *sArray)
{
	HRESULT hr;
	
	if (sArray != NULL) {
//		hr = SafeArrayUnlock(sArray->parray);  // MTWX29299 fix
//		if (hr == S_OK) 
		{
			hr = SafeArrayDestroy(sArray->parray);
		}
	}

	if (hr == S_OK) {
		return VariantClear(sArray);
	}

	return E_FAIL;
}

void deleteProperty(PropertyMap &propertyMap, char *propName) 
{
	PropertyMapIter p = propertyMap.find(propName);

	if (p != propertyMap.end()) {
		VariantClear(p->second);
		delete p->second;
		propertyMap.erase(p);
	}

}