
#ifndef __OSBDM_UTILITIES_H__
#define __OSBDM_UTILITIES_H__

#include <atlbase.h>
#include <map>

typedef std::map<const char *,CComVariant *> PropertyMap;
typedef PropertyMap::iterator PropertyMapIter;


#define INIT_SAFEARRAY_ACCESS(SA,ELEMENTS_OUT)  { \
			HRESULT _hr; \
			long _lowerBound;\
			long _upperBound; \
			int SA_INDEX; \
			_hr = SafeArrayGetLBound((SA),1,&_lowerBound); \
		/*	ASSERT_RV(SUCCEEDED(_hr),_hr); */ \
			_hr = SafeArrayGetUBound((SA),1,&_upperBound);\
		/*	ASSERT_RV(SUCCEEDED(_hr),_hr); */ \
			_hr = SafeArrayAccessData((SA),(void HUGEP**)&ELEMENTS_OUT); \
		/*	ASSERT_RV(SUCCEEDED(_hr),_hr); */
			
#define BEGIN_SAFEARRAY_LOOP \
		for (SA_INDEX=_lowerBound;SA_INDEX<=_upperBound; SA_INDEX++) { 
		

#define END_SAFEARRAY_LOOP  } }

#define END_SAFEARRAY_SCOPE }

CComVariant * createVariantSafeArrayOfBSTRs(char * inArray[],int size);
HRESULT destroyVariantSafeArrayOfBSTRs(CComVariant *sArray);
void deleteProperty(PropertyMap &propertyMap, char *propName);

#endif //__OSBDM_UTILITIES_H__