/*
    Open Source BDM - message log
    Copyright (C) 2005

	Change History:
	 ------------------
	 *****Prominent Notice-This software was modified from TBDML software - 12/05


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <windows.h>
#include <stdio.h>
#include "log.h"

#ifdef LOG
	FILE *log_file=NULL;
#endif

/* provides print function which prints data into a log file */
#ifdef LOG
	void print(const char *format, ...) {
		va_list list;
		va_start(list, format);
		fprintf(log_file, "%04.3f: ",1.0*GetTickCount()/1000);
		vfprintf(log_file, format, list);
		va_end(list);
	}
	void print_dump(unsigned char *data, unsigned int size) {
		unsigned int i=0;
		while(size--) {
			fprintf(log_file,"%02X ",*(data++));
			if (((++i)%16)==0) fprintf(log_file,"\r\n");
		}
		if (((i)%16)!=0) fprintf(log_file,"\r\n");
	}
#else
	void print(const char *format, ...) {
		return;
	}
	void print_dump(unsigned char *data, unsigned int size) {
		return;
	}
#endif

